from osgeo import gdal, ogr, osr

print "To test, make sure libproj.so is not available (e.g. mv /usr/lib/libproj.so /usr/lib/libproj.so.bak)"

ds = ogr.Open("test.shp")
layer = ds.GetLayer()
feature = layer.GetFeature(0)
geometry = feature.GetGeometryRef()
source = geometry.GetSpatialReference()
EPSG4326 = osr.SpatialReference()
EPSG4326.ImportFromEPSG(4326)
print
print "Creating a transform when libproj.so is not available will cause an error to be written to stderr..."
transform = osr.CoordinateTransformation(geometry.GetSpatialReference(), EPSG4326)
print

print "Unless gdal.UseExceptions() is called, in which case we get ..."
gdal.UseExceptions()
transform = osr.CoordinateTransformation(geometry.GetSpatialReference(), EPSG4326)
print "...nothing (and no possibility to catch the error)"
print

print "Using the transform creates the following error..."
geometry.Transform(transform)
